;------------------------
; Save parameters to EEPROM
;
_startSave	bcf	INTCON, GIE
	bcf	INTCON, GIE
	call	_saveToEEPROM
_initJumper	btfss	sw2	; wait for EEPROM init switch release
	goto	$-1	
	goto	_resetVector	

_saveToEEPROM		
	banksel	EEADR
	clrf	EEADR
	movfw	eepromAddress
	movwf	eepromValidate
	call	_EEPROMwrite

	incf	EEADR,F	
	movfw	eepromBitRate
	addwf	eepromValidate,F
	call	_EEPROMwrite

	incf	EEADR,F	
	movfw	eepromInactive
	addwf	eepromValidate,F
	call	_EEPROMwrite

	incf	EEADR,F	
	movfw	eepromValidate
	sublw	0x00
	call	_EEPROMwrite
	banksel	PORTA
	return

_EEPROMwrite	
	banksel	PIR2
	bcf	PIR2, EEIF
	banksel	EEADR
	movwf	EEDATA
	banksel	EECON1
	bcf	EECON1, EEPGD
	bsf	EECON1, WREN
	bcf	INTCON, GIE
	btfsc	INTCON, GIE
	goto	$-2	; ensure GIE wasn't reset by Int Handler
	
	movlw	0x55
	movwf	EECON2
	movlw	0xAA
	movwf	EECON2
	bsf	EECON1, WR
	bcf	EECON1, WREN
	bsf	INTCON, GIE
	banksel	PIR2
_waitWriteDone	btfss	PIR2, EEIF
	goto	_waitWriteDone
	banksel	EEADR
	return


_EEPROMread	nop
	banksel	EEADR
	movwf	EEADR
	banksel	EECON1
	bcf	EECON1, EEPGD
	bsf	EECON1, RD
	banksel	EEDATA
	movfw	EEDATA
	banksel	PORTA
	return


_EEPROMboot	clrw
	call	_EEPROMread
	movwf	eepromAddress
	movwf	eepromValidate
	movlw	.1
	call	_EEPROMread
	movwf	eepromBitRate
	addwf	eepromValidate,F

	movlw	.2
	call	_EEPROMread
	movwf	eepromInactive
	addwf	eepromValidate,F

	movlw	.3
	call	_EEPROMread
	addwf	eepromValidate,F

	skpnz
	return

_EEPROMbadsum
	movlw	.0	; Set address to 0
	movwf	eepromAddress

	movlw	defaultBitRate
	movwf	eepromBitRate
	
	clrf	eepromInactive

	goto	_startSave


