;----------------------------------------------------------------------------- 
	; values correct for 8Mhz Fosc, 
_bitRateLookup	clrf 	PCLATH
	addwf  	 PCL,F 
	retlw  	 .103    ; 0, 1200 low speed BRG
        	retlw  	 .207    ; 1, 2400 high speed BRG
        	retlw	   .51    ; 2, 9600 high speed BRG
        	retlw 	  .25     ; 3, 19200 high speed BRG
_cmdFuncEnd   	retlw 	  .12     ; 4, 38400 high speed BRG


	IF (HIGH $ != 0)
	error "Lookup table in zcode_cmdfuncs.inc not in program memory page 0"
	ENDIF


_command        bcf	flags, rxNewCmd
	decf	Data2,W ; data2 == 0x01
        	iorwf	Data3,W ; data3 == 0x00 
        	skpz            ; if result == zero process command 
        	return 


highestCmd equ     .10 	
	movlw   	~highestCmd 
        	addwf   	Data0,W 
        	skpnc   
        	return 
        	movfw 	Data0 
        	addwf   	PCL,F 
        	return    		; 0 Keep awake
        	goto    	_flushColour   	; 1 Transfer (in zcode_pwmcalc.inc)
        	goto    	_startSave	; 2 save to EEPROM (in zcode_eeprom.inc)
        	goto    	_setAddress   	; 3 set Address 
        	goto    	_setBitRate   	; 4 set Bit Rate 
        	goto	_shutDown	; 5 shutdown PWM output
	goto	_inactiveTO	; 6 inactivity timeout enable
	goto    	_servoPosition 	; 7 Transfer (in zcode_pwmcalc.inc)

	goto    	_setServo1 	; 8 Transfer 
	goto    	_setServo2 	; 9 Transfer 
	goto    	_setServo3 	; 10 Transfer 


_setAddress	btfsc   Data1,7 	; ignore if new address bit 7 is set
        	return 	
        	movfw   Data1 
        	movwf   eepromAddress 
               	return 


_setBitRate	movlw   ~.4 
        	addwf   Data1,W 
        	skpnc 
        	return 
	movfw   Data1
        	movwf   eepromBitRate 
        	return 

_antiPiracy	movlw	HIGH _text1	; anti-piracy code
	movwf	PCLATH
	movlw	LOW _text1
	movwf	PCL



_shutDown	movf	Data1,F
	bnz	_shutUp
	bcf	INTCON, GIE
	bcf	INTCON, GIE
	bcf	T1CON, TMR1ON

	movfw	ServoPort
	andlw	~(1<<servo1 | 1<<servo2 | 1<<servo3)
	movwf	ServoPort
	bsf	flags2,pwmShutdown
	return


_shutUp	bsf	INTCON, GIE
	movlw	0xF0
	movwf	TMR1H
	bsf	T1CON,TMR1ON
	bcf	flags2, pwmShutdown
	return

_inactiveTO	movf	Data1,F
	movwf	eepromInactive
	return

_flushColour	bcf	flags, rxNewCol	; clear Servo Data ready flag
	return		; if colour transfer command received


_setServo1	movfw	Data1
	movwf	s1pos
	movwf	servo1NEW
	bcf	flags, s1done
	bsf	T1CON, TMR1ON	
	return

_setServo2	movfw	Data1
	movwf	s2pos
	movwf	servo2NEW
	bcf	flags, s2done
	bsf	T1CON, TMR1ON	
	return


_setServo3	movfw	Data1
	movwf	s3pos
	movwf	servo3NEW
	bcf	flags, s3done
	bsf	T1CON, TMR1ON	
	return